#	This is a generic system.mk file for
#
#       Autoconfig done by: Kurt Siegl <siegl@risc.uni-linz.ac.at>
#
#	Directories:
#	   LIBDIR     - where the lib files will go (.sysdef, .motd, etc)
#	   XTREKDIR   - root src dir
#	   XTREKOWNER - Owner of the game

XTREKDIR = .
LIBDIR = /tmp
XTREKOWNER = netrek

PORT = -DPORT=2592

#       Some systems dont have install so you may need to use cp instead
#	A script call install in the root dir is also provided but isn't
#       very robust. To use this put the full path

SHELL = /bin/sh
INSTALL = /usr/ucb/install -c
INSTALLPROG = ${INSTALL}
INSTALLDATA = ${INSTALL} -m 644

#	Compiler:
#	   NOTE: many systems' /bin/cc may choke on much of the code in 
#		 ntserv/ use with # caution!

CC  = gcc
CPP = gcc -E
LN  = ln -s

#	Optimizer flags:
#	   +O3  - Highest optimization
#	   -O	  Normal optimization (+O2)
#	   -g	  Debugging
#	   -O -g  is useful to help debugging while still optimized

OPT = -g
#OPT = -O6 -fomit-frame-pointer

#LINKFLAGS = -s -N

# Compile in parallel
# PMAKE = &

# compile in parallel with gnu's parallel make!
# MAKE = gmake -j 8
MAKE = make

#	SysV defines:
#	Use only -lm (EXTRALIBS) if you're not on SysV

EXTRALIBS  = $(LINKFLAGS)   -lsocket -lnsl -lm

#	Some systems need X11R5 in the include path
#	Comment out if you don't need this

EXTRAINCS = # -I/usr/local/X11R5/include



#	Some systems don't have strdup() or random()
#	Comment out if you have strdup() and random()

#STRDUPC = strdup.c random.c
#STRDUPO = strdup.o random.o
RANDOMO = 

# Location of X include files if not standard
# Use -I<path>
X11INCLUDE = -I/usr/X11R5/include

# Name of X libraries 	(xsg only)
# Put -L<path> before library if non-standard location.
X11LIB = -L/usr/X11R5/lib -lX11



# RSA stuff

RSA_FLAGS =  -DRSA
RSA_OBJS =  rsa_key.o rsa_util.o
RSA_SRC =  rsa_key.c rsa_util.c
RSA_INCS = 
RSA_LIBS = -lmp

FLAGS = $(EXTRAFLAGS) $(RSA_FLAGS) -DTSANG_MODS

# In config.h now
DIRS = # -DLIBDIR=\"$(LIBDIR)\"

